import os
import datetime

class CLI:
    def __init__(self, command, do_print = True):
        self.username = os.getenv("LOGIN_ID")
        self.groupname = os.getenv("ROLE_ID")
        self.command = command
        self.do_print = do_print
        self.command_timestamp = datetime.datetime.now()

        self.output = os.popen('/usr/confd/bin/confd_cli -C --user=' + self.username + ' --group=' + self.groupname + ' << EOF\n' + self.command + '\nEOF').read()

        if self.do_print:
            #print('!Username: ' + self.username)
            #print('!Groupname: ' + self.groupname)
            print('!Command: ' + self.command)
            print('!Time: ' + self.command_timestamp.strftime('%c\n'))
            print(self.output)

    def get_output(self):
        return (self.output.splitlines())

    def rerun(self):
        self.command_timestamp = datetime.datetime.now()

        print('!Command: ' + self.command)
        print('!Time: ' + self.command_timestamp.strftime('%c\n'))
        print(os.popen('/usr/confd/bin/confd_cli -C --user=' + self.username + ' --group=' + self.groupname + ' << EOF\n' + self.command + '\nEOF').read())
