#!/bin/bash

# Debug flag

DEBUG=0

#
# Subroutines
#
ECHO ()
{
    if [ $DEBUG -eq 1 ]; then
        echo "$@"
    fi
}

#
# Main
#
FIPS_CFG=`/fabos/link_abin/fipscfg --showall`
echo $FIPS_CFG | /bin/grep -iq "FIPS Selftests: Enabled"
FIPS_SELFTEST=$?

if [[ "$FIPS_SELFTEST" -eq 0 ]]; then
    echo "python NOT available in FIPS mode"
    exit 1
fi

PYTHONVERSION=`ls /usr/local/python | cut -d '/' -f1`

if [ -z "$PYTHONVERSION" ]; then
    PYTHONVERSION="3.3.2"
fi

unset PYTHONHOME
export PYTHONPATH=/etc/fabos/Dcmd/python
export PYTHONSTARTUP=/etc/fabos/Dcmd/python/pythonStarup.py

ECHO "NUMBER OF ARGS: $#"

for i in "$@"; do
    ECHO "ARG: $i"
done

export LOGIN_ID=${1##*=}
shift
export ROLE_ID=${1##*=}
shift

ECHO "LOGIN_ID: $LOGIN_ID"
ECHO "ROLE_ID: $ROLE_ID"

/usr/local/python/${PYTHONVERSION}/bin/python3 "$@"

exit $?
