#! /bin/bash

# This script will be executed when the VCS mode is enabled/disabled.
# This script can also be called after the FWDL
#
# Cmdline Arguments:
#  $1 = 'enable' or 'disable'
#  $2 = Base directory
#       "" during VCS enable/disable CLIs
#       "/mnt" after the FWDL.

VCS_ONLY_FILES=( fcoe.ccl \
                 fc.ccl \
               )

NUM_VCS_ONLY_FILES=`expr ${#VCS_ONLY_FILES[@]} - 1`
BASE_DIR=$2/etc/confd;
LOG_FILE=$2/var/log/vcs_set_mode.log

date >> $LOG_FILE

echo "Entering BASE Dir: $BASE_DIR" >> $LOG_FILE
cd $BASE_DIR

if [ "$1" == "enable" ]; then
    for i in `seq 0 $NUM_VCS_ONLY_FILES`
    do
        rm -f $BASE_DIR/${VCS_ONLY_FILES[$i]}
        echo "Enabling CLI file: ${VCS_ONLY_FILES[$i]}" >> $LOG_FILE
        ln -s VcsOnly/${VCS_ONLY_FILES[$i]} $BASE_DIR/${VCS_ONLY_FILES[$i]}
    done
    
elif [ "$1" == "disable" ]; then
    for i in `seq 0 $NUM_VCS_ONLY_FILES`
    do
        echo "Disabling CLI file: ${VCS_ONLY_FILES[$i]}" >> $LOG_FILE
        rm -f $BASE_DIR/${VCS_ONLY_FILES[$i]}
    done
fi
