#!/bin/sh 

# *******************************************
# Collect VCS /DCM
# *******************************************
# Please use date cmd while doing an echo
#
#
# *******************************************

DCMD_SUPPORT_SAVE_LOG="/etc/fabos/Dcmd/Dcmdlogs.tar"
CCMD_SUPPORT_SAVE_LOG="/etc/fabos/Ccmd/Ccmdlogs.tar"
NOSSMD_SUPPORT_SAVE_LOG="/etc/fabos/NosSmd/NosSmdlogs.tar"

DB_DUMPALL_FILE="/etc/fabos/Dcmd/SSHOW_AllDatabases.dump"
CCMD_DB_DUMPALL_FILE="/etc/fabos/Ccmd/SSHOW_AllDatabases.dump"

CCMD_LS_OUTPUT_FILE="/etc/fabos/Ccmd/ls_output.txt"
LS_OUTPUT_FILE="/etc/fabos/Dcmd/ls_output.txt"
DISTRIBUTED_LOG_OUTPUT_FILE="/etc/fabos/Dcmd/distributed_log_output.txt"
DISTRIBUTED_LOG_CCMD_OUTPUT_FILE="/etc/fabos/Ccmd/distributed_log_output.txt"
FWDL_DB_COPY_LOG_FILE="fwdl_db_copy_log"
PG_VERSION=`ls /usr/local/postgresql | cut -d '/' -f1`
SERVICE_DEBUG_INFORMATION_FILE="/etc/fabos/Dcmd/service_debug_information.txt"
CCMD_SERVICE_DEBUG_INFORMATION_FILE="/etc/fabos/Ccmd/service_debug_information.txt"
DCM_CLIENT_BIN="/fabos/libexec/DcmClient.Linux.powerpc"


dcm_confd_log_upload()
{
	#Collect Confd logs.
	/bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /var/confd/log/*

}

dcm_vcenter_log_upload()
{
    #Collect Vcenter DBs.
    /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /tmp/vCenter/*.db
    /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /tmp/vCenter/*.db.new
    /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /var/tmp/vCenter/*.db
    /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /var/tmp/vCenter/*.db.new
    /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /tmp/vCenter/*
    /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /var/tmp/vCenter/*

}

dcm_confd_log_clear()
{
	#Collect Confd logs.
	return 0

}

dcm_distributed_log_upload()
{
    #Collect distributed audit log output
{   /usr/confd/bin/confd_cli -C --user _support_save_ << EOF
unhide debug
secret
show log audit non-support-save limit 1000
EOF
} > $DISTRIBUTED_LOG_OUTPUT_FILE

    /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} $DISTRIBUTED_LOG_OUTPUT_FILE
    /bin/rm -f $DISTRIBUTED_LOG_OUTPUT_FILE

   local CLUSTER_CONF=`cat /etc/fabos/Dcmd/cluster.conf`
    local VCS_CONF=`cat /etc/fabos/Dcmd/vcs.conf`

    if [[ "$CLUSTER_CONF" == "0" && "$VCS_CONF" != "0000" ]]; then
{   /usr/confd/bin/confd_cli -C --user _support_save_ << EOF
unhide debug
secret
show log audit-ccm non-support-save-ccm limit 1000
EOF
} > $DISTRIBUTED_LOG_CCMD_OUTPUT_FILE

        /bin/tar rvf ${CCMD_SUPPORT_SAVE_LOG} $DISTRIBUTED_LOG_CCMD_OUTPUT_FILE
        /bin/rm -f $DISTRIBUTED_LOG_CCMD_OUTPUT_FILE
    fi



}

dcm_event_handler_log_upload()
{
    /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /etc/fabos/Dcmd/python/scripts/*
}

dcm_event_handler_log_clear()
{
    /bin/rm -f /etc/fabos/Dcmd/python/scripts/*.log*
}

dcm_plugin_log_upload()
{
	#Invoke DCM plugin specific log upload function.
	
	#Confd specific logs
	dcm_confd_log_upload

    #Distributed logs
    dcm_distributed_log_upload

    #Event-handler scripts and logs
    dcm_event_handler_log_upload
    
    #Vcenter logs
    dcm_vcenter_log_upload
}

dcm_plugin_log_clear()
{
	#Invoke DCM plugin specific log cleanup function.

	#Cleanup confd logs
	dcm_confd_log_clear

    #Cleanup event-handler logs
    dcm_event_handler_log_clear
}

collect_ls_output()
{
    #Collect the list of files under /etc/fabos/Dcmd/, /etc/fabos/Dcmd/startupFile , /var/config/vcs/scripts/ 
    /bin/echo "/bin/ls -alR /etc/fabos/Dcmd/" > ${LS_OUTPUT_FILE}
    /bin/ls -alR /etc/fabos/Dcmd/ >> ${LS_OUTPUT_FILE}
    /bin/echo "" >> ${LS_OUTPUT_FILE}
    /bin/echo "**************************************************************************************" >> ${LS_OUTPUT_FILE}
    /bin/echo "/bin/ls -alR /etc/fabos/Dcmd/startupFile" >> ${LS_OUTPUT_FILE}
    /bin/ls -alR /etc/fabos/Dcmd/startupFile >> ${LS_OUTPUT_FILE}
    /bin/echo "" >> ${LS_OUTPUT_FILE}
    /bin/echo "**************************************************************************************" >> ${LS_OUTPUT_FILE}
    /bin/echo "/bin/ls -alR /var/config/vcs/scripts/" >> ${LS_OUTPUT_FILE}
    /bin/ls -alR /var/config/vcs/scripts/ >> ${LS_OUTPUT_FILE}
    
    /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} ${LS_OUTPUT_FILE}

    #Collect the list of files under /etc/fabos/Ccmd
    /bin/echo "/bin/ls -alR /etc/fabos/Ccmd/" > ${CCMD_LS_OUTPUT_FILE}
    /bin/ls -alR /etc/fabos/Ccmd/ >> ${CCMD_LS_OUTPUT_FILE}
    /bin/echo "" >> ${CCMD_LS_OUTPUT_FILE}
    /bin/echo "**************************************************************************************" >> ${CCMD_LS_OUTPUT_FILE}
    
    /bin/tar rvf ${CCMD_SUPPORT_SAVE_LOG} ${CCMD_LS_OUTPUT_FILE}

}

collect_startup_file()
{
    #Collect the /var/config/vcs/scripts/startup-config

	if [ -f /var/config/vcs/scripts/startup-config ]
	then
		/bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /var/config/vcs/scripts/startup-config
	fi
}

collect_service_debug_information()
{
    DCMD_PROCESS="Dcmd.Linux.powerpc"
    CCMD_PROCESS="Ccmd.Linux.powerpc"

    SERVICE_LIST="27,59" #(ClusterLocalOM, VcsFabricLocalOM).  This list must be in ascending order!!! 
    CCMD_MGMT_PORT=7110

    #Test if processes are running
    DCMD_PID=`/sbin/pidof ${DCMD_PROCESS}`
    DCMD_RUNNING=$?

    CCMD_PID=`/sbin/pidof ${CCMD_PROCESS}`
    CCMD_RUNNING=$?

    if [ ${DCMD_RUNNING} -eq 0 ]; then
        #Collect service debug information for Dcmd
        /bin/echo "${DCMD_PROCESS} (PID: ${DCMD_PID})" > ${SERVICE_DEBUG_INFORMATION_FILE} 
        /bin/echo "${DCM_CLIENT_BIN} service list" >> ${SERVICE_DEBUG_INFORMATION_FILE}   
        ${DCM_CLIENT_BIN} service list >> ${SERVICE_DEBUG_INFORMATION_FILE}   
        /bin/echo "${DCM_CLIENT_BIN} debug getdebuginformation ${SERVICE_LIST}" >> ${SERVICE_DEBUG_INFORMATION_FILE}   
        ${DCM_CLIENT_BIN} debug getdebuginformation ${SERVICE_LIST} >> ${SERVICE_DEBUG_INFORMATION_FILE}   

        /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} ${SERVICE_DEBUG_INFORMATION_FILE}
    fi

    if [ ${CCMD_RUNNING} -eq 0 ]; then
        #Collect service debug information for Ccmd
        /bin/echo "${CCMD_PROCESS} (PID: ${CCMD_PID})" > ${CCMD_SERVICE_DEBUG_INFORMATION_FILE} 
        /bin/echo "${DCM_CLIENT_BIN} -serverport ${CCMD_MGMT_PORT} service list" >> ${CCMD_SERVICE_DEBUG_INFORMATION_FILE}   
        ${DCM_CLIENT_BIN} -serverport ${CCMD_MGMT_PORT} service list >> ${CCMD_SERVICE_DEBUG_INFORMATION_FILE}   
        /bin/echo "${DCM_CLIENT_BIN} -serverport ${CCMD_MGMT_PORT} debug getdebuginformation ${SERVICE_LIST}" >> ${CCMD_SERVICE_DEBUG_INFORMATION_FILE}   
        ${DCM_CLIENT_BIN} -serverport ${CCMD_MGMT_PORT} debug getdebuginformation ${SERVICE_LIST} >> ${CCMD_SERVICE_DEBUG_INFORMATION_FILE}   

        /bin/tar rvf ${CCMD_SUPPORT_SAVE_LOG} ${SERVICE_DEBUG_INFORMATION_FILE}
    fi
}

collect_core_files()
{
    #This is a workaround to collect any Dcmd/Ccmd corefiles that occur during framework bootup.
    
    #Collect any core files found under /etc/fabos/Dcmd and /etc/fabos/Ccmd.
    #This may occur if there is a Dcmd/Ccmd crash that occurs during framework bootup.
    #After framework bootup, Dcmd/Ccmd core files will be generated under /core_files/[DC]cmd/ 

    #Gzip any core files found
    gzip /etc/fabos/Dcmd/core* > /dev/null 2>&1
    gzip /etc/fabos/Ccmd/core* > /dev/null 2>&1

    /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /etc/fabos/Dcmd/core.*
    /bin/tar rvf ${CCMD_SUPPORT_SAVE_LOG} /etc/fabos/Ccmd/core.*
}

dcm_log_upload()
{

PID=$$
#This is required since large memory dump requires more cpu cycles. Defect 372319
echo "`date` : Bumping CPU priority of $PID to -1"

renice -1 -p $PID

echo "`date` : current nice value -> `ps -o pid,nice -p $PID`"

echo "`date` : SS invoked for DCM components"

#PG_DUMPALL cmd:-/usr/local/postgresql/${PG_VERSION}/bin/pg_dumpall --file=/etc/fabos/Dcmd/SSHOW_AllDatabases.dump --port=9013

PG_DUMPALL_EXE="/usr/local/postgresql/${PG_VERSION}/bin/pg_dumpall"

PORT=9013
CCMD_PORT=7013

PG_DUMPALL_CMD="${PG_DUMPALL_EXE} -c --file=${DB_DUMPALL_FILE} --port=${PORT}"
CCMD_PG_DUMPALL_CMD="${PG_DUMPALL_EXE} -c --file=${CCMD_DB_DUMPALL_FILE} --port=${CCMD_PORT}"

#To do:- Currently the path is hard-coded, come up with a generic fix.
export PATH=$PATH:/usr/local/postgresql/${PG_VERSION}/bin
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/postgresql/${PG_VERSION}/lib

echo "`date` : Pgdump being invoked on Dcmd"
#Dump all the Databases
${PG_DUMPALL_CMD}

echo "`date` : Pgdump being invoked on Ccmd"
${CCMD_PG_DUMPALL_CMD}

echo "`date` : Pgdump finished"

#To do:- #	If Flash is 100% full, then create the tar in /mnt.

#Collect the Dcmd logs and cfg file
/bin/tar cvf ${DCMD_SUPPORT_SAVE_LOG} /etc/fabos/Dcmd/Dcmd* /etc/fabos/Dcmd/*.pgd /etc/fabos/Dcmd/ConfigSnapshot ${DB_DUMPALL_FILE}  
/bin/tar cvf ${CCMD_SUPPORT_SAVE_LOG} /etc/fabos/Ccmd/Ccmd* /etc/fabos/Ccmd/*.pgd ${CCMD_DB_DUMPALL_FILE}
/bin/tar cvf ${NOSSMD_SUPPORT_SAVE_LOG} /etc/fabos/NosSmd/NosSmd* /etc/fabos/NosSmd/core.*

#Collect the Dcmd cluster and vcs conf file
/bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /etc/fabos/Dcmd/cluster.conf /etc/fabos/Dcmd/vcs.conf

#Collect the DcmClient logs 
/bin/cp /DcmClient.Linux.powerpc.trc* /etc/fabos/Dcmd/.
/bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /etc/fabos/Dcmd/DcmClient.Linux.powerpc.trc*

#Collect postgres log generated after firmware download 
/bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /etc/fabos/Dcmd/${FWDL_DB_COPY_LOG_FILE}*

#Collect postinst triggered initializeDcmdDB log file
/bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} /etc/fabos/Dcmd/initializedcmdb.log
/bin/tar rvf ${CCMD_SUPPORT_SAVE_LOG} /etc/fabos/Ccmd/initializeccmdb.log

#Collect ls command ouput in /var/config/vcs/scripts/ and /etc/fabos/Dcmd/
collect_ls_output

#Collect the startup file
collect_startup_file

#Collect service debug information 
collect_service_debug_information

#Gzip and collect any core files found under Dcmd/Ccmd path
collect_core_files

#Invoke function to upload plugin specific logs collected during supportsave
dcm_plugin_log_upload

#Concatenate before coredump collection since that may take more time leading to timeout
/bin/tar --concatenate --file=${DCMD_SUPPORT_SAVE_LOG} ${CCMD_SUPPORT_SAVE_LOG}
/bin/tar --concatenate --file=${DCMD_SUPPORT_SAVE_LOG} ${NOSSMD_SUPPORT_SAVE_LOG}

#Invoke coredump on Dcmd & Ccmd
#
# Commenting out gcore collection :TR369020
#
#var1="Dcmd"
#dcm_core_dump $var1
#var1="Ccmd"
#dcm_core_dump $var1

echo "`date` : SS Finished for DCM components"

}

dcm_core_dump()
{
    #create Core and zip it
    GCORE_EXE="/usr/bin/gcore"
    SUFFIX=".Linux.powerpc"
    DCM_ROOT="/etc/fabos/"

    if [ $var1 == "Dcmd" ]
    then
        DAEMON="Dcmd"
    elif [ $var1 == "Ccmd" ]
    then
        DAEMON="Ccmd"
    else
        echo "Wrong Daemon name!!!"
    fi
    

    PID=`ps auxww | grep -w "${DAEMON}${SUFFIX}" | grep -v grep | awk '{print $2}'`
        # if Daemon is running then we will take the live core
    if [ "" != "$PID" ]
    then
            echo "`date` : Invoking gcore on $DAEMON..."
            if [ -f $GCORE_EXE ]
            then
                $GCORE_EXE -o "${DCM_ROOT}${DAEMON}/core.${DAEMON}" $PID
                if [ -f "${DCM_ROOT}${DAEMON}/core.${DAEMON}.${PID}" ]
                then
                    echo "`date` : Zipping core file->${DCM_ROOT}${DAEMON}/core.${DAEMON}.${PID}"     
                    gzip -1f "${DCM_ROOT}${DAEMON}/core.${DAEMON}.${PID}"  
                    if [ $? -eq 0 ]
                    then 
                        echo "`date` : Appending the coredump zip file"
                        #Append to Dcmd logs directly. No need to concatenate later
                        /bin/tar rvf ${DCMD_SUPPORT_SAVE_LOG} "${DCM_ROOT}${DAEMON}/core.${DAEMON}.${PID}.gz"
                        echo  "`date` : removing the coredumpzip"
                        /bin/rm -f "${DCM_ROOT}${DAEMON}/core.${DAEMON}.${PID}.gz"
                    else
                        /bin/rm -f "${DCM_ROOT}${DAEMON}/core.${DAEMON}.${PID}.gz"
                        /bin/rm -f "${DCM_ROOT}${DAEMON}/core.${DAEMON}.${PID}"    
                        echo  "`date` : gzip failed with status $?"
                    fi
                else
                    echo " `date` : GCORE on $DAEMON with Pid:$PID failed"
                fi
            else
                echo "`date` : WARNING! $GCORE_EXE not available unable to dump core on Dcmd."
            fi
    else
           echo "`date` : WARNING! $DAEMON not running hence cannot dump core."
    fi
}

dcm_log_clear()
{
	#Delete Dcmdlogs
	if [ -f ${DB_DUMPALL_FILE} ]
	then
		/bin/rm ${DCMD_SUPPORT_SAVE_LOG}* ${DB_DUMPALL_FILE} ${LS_OUTPUT_FILE}
	fi
	if [ -f ${CCMD_DB_DUMPALL_FILE} ]
	then
		/bin/rm ${CCMD_SUPPORT_SAVE_LOG}* ${CCMD_DB_DUMPALL_FILE} ${CCMD_LS_OUTPUT_FILE}
	fi
	
    /bin/rm -f ${SERVICE_DEBUG_INFORMATION_FILE}
    /bin/rm -f ${CCMD_SERVICE_DEBUG_INFORMATION_FILE}

    /bin/rm -f /etc/fabos/Dcmd/DcmClient.Linux.powerpc.trc*
    /bin/rm -f /etc/fabos/Dcmd/core*
    /bin/rm -f /etc/fabos/Ccmd/core*

	#Invoke function to cleanup plugin specific logs collected during supportsave
	dcm_plugin_log_clear

}

# ***** Main ****************************************

if [ "$1" = "--upload" ]; then
    dcm_log_upload
elif [ "$1" = "--clear" ]; then
    dcm_log_clear
else
	echo "Invalid input"
fi
